unit CannySub;

interface

uses Windows, Graphics, Math,StrUtils, SysUtils;

procedure Canny(const bm_in: TBitmap; const bm_out: TBitmap;
                GaussSize: integer; GaussTheta: double;
                lowerThreshold, upperThreshold: byte; addThreshold: Word;
                ColorMap, Level: integer);

implementation

type
  TLongArray = array[0..0] of Cardinal;          // z̃|C^[̂ݕKvȂ̂Œ[0..0]łnj
//  TLongArray = array[0..65535] of integer;
  PLongArray = ^TLongArray;

var
  Pbm_In, Pbm_Out: PLongArray;
  tmp_In  : array of Cardinal;
  edgeDir : array of Cardinal;
  gradient: array of Word;                        // \[xl̕ۑ ől1442
  Hyst    : array of Cardinal;

  WPicth          : integer;
  Width, Height   : integer;
  ColorMapMode    : integer;
  Threshold       : Word;
  Maxg            : Word;


// fonctions diverses...
//==============================================================================
// colormap mode check
function colormapcheck(i: integer): Boolean;
var
  ic : integer;
begin
  Result := False;
  ic := i mod 4;
  if ic = 3 then exit;                  // SoCg(tOoCg)́A[hɊ֌WȂȂ
  if ic = 0 then begin                  // PoCg(blue)́A[hɊ֌WȂ
    Result := True;                     //  ColorMapMode = 1 ȊO PoCg(blue)̂ݎgp܂
    exit;
  end;
  if ColorMapMode = 1 then              // ColorMapmode RGB ͑SĂ̐F B, g, r 
    Result := True;
// if ((ColorMapMode <> 1) and (i mod 4 <> 0)) or (i mod 4 = 3)) then Result := False
//                                                               else Result := True;
// ₷`ɏ܂Aۂɂ͏LQsƓłB
end;

// r g b a byte data to 32bit color data
function RGBA(r, g, b, a: Byte): COLORREF;
begin
  Result := (r or (g shl 8) or (b shl 16) or (a shl 24));
end;

// Fϊ
function ArcEnCiel(a: Word): COLORREF;
                                           // gradient ̍ől 1140     1140 = 19 * 60
  function aconv(ain : Word): byte;
  begin
    result := 17 * (ain mod 60) shr 2;
  end;

begin         // B    G    R
  result := RGB(255, 255, 255);
  case (a div 60) mod 6 of
    0: result := RGB(           255,       aconv(a),              0);
    1: result := RGB(255 - aconv(a),            255,              0);
    2: result := RGB(             0,            255,       aconv(a));
    3: result := RGB(             0, 255 - aconv(a),            255);
    4: result := RGB(      aconv(a),              0,            255);
    5: result := RGB(           255,              0, 255 - aconv(a));
  end;
end;

// rgb to gray scale
function RGBtoGray(c: COLORREF): COLORREF;
var
  r, g, b: cardinal;
begin
  r := (c and $FF0000) shr 16;
  g := (c and $00FF00) shr  8;
  b := (c and $0000FF) ;

  c := (r + g + b) div 3;                   // GbWoȂ̂ŕϒlgp܂B
//  c := (r * 38 + g * 75 + b * 15) shr 7;    // NTSCWϊ
  result := $010101 * byte(c);              // RGBlZbg
end;

function getPixel(pt: pointer; xx, yy: integer): COLORREF;
begin
  result:= PLongArray(pt)[xx + yy * Width];
end;

procedure SetPixel(pt: pointer; xx, yy: integer; px: COLORREF);
begin
  PLongArray(pt)[xx + yy * Width] := px;
end;

function getBytePixel(pt: pointer; xx, yy: integer): Byte;
begin
  if xx < 0 then                                       // ͈͂}CiCɒꍇԊO̒lőp
    if xx mod 4 = 0 then xx := 0                       // ͈͂𒴂̂̓KEVAtB^[
                    else xx := 4 + xx mod 4;
  if yy < 0 then yy := 0;
  if xx > WPicth - 1 then xx := WPicth - 4 + xx mod 4; // ͈͂vXɒꍇԊO̒lőp
  if yy > Height - 1 then yy := Height - 1;            // ͈͂𒴂̂̓KEVAtB^[
  result:= PByteArray(pt)[xx + yy * WPicth];
end;

procedure SetBytePixel(pt: pointer; xx, yy: integer; px: byte);
begin
  PByteArray(pt)[xx + yy * WPicth] := px;               // Blue oCg
  if ColorMapMode <> 1 then begin                       // RGB [hȊO r,g,b l
    PByteArray(pt)[xx + 1 + yy * WPicth] := px;
    PByteArray(pt)[xx + 2 + yy * WPicth] := px;
    PByteArray(pt)[xx + 3 + yy * WPicth] := 0;          // SoCgڃJ[tO͂O[Zbg
  end;
end;

procedure copyimage(pt_In, pt_Out: pointer);
var
  i, j: integer;
begin
  for j := 0 to Height - 1 do
    for i := 0 to Width - 1 do
      SetPixel(pt_Out, i, j, GetPixel(pt_In, i, j));
end;

//==============================================================================
// \[xl@X΂̑傫J[\
procedure ColorGradient;
var
 i, j: integer;
 Msc : double;
begin
  Msc := 359 / Maxg;           // ől359ɂW
  for j := 0 to Height - 1 do
    for i := 0 to Width - 1 do
      SetPixel(Pbm_Out, i, j, Arcenciel(Round(gradient[i * 4 + j * WPicth] * Msc)));
end;

// \[xɂXΕF\
procedure ColorDirection;
var
  i, j: integer;
  dc  : Word;
const                               // blue     red    yellow   green
  EdgeColor: array[0..3] of Tcolor = ($00001, $010000, $010100, $000100);
begin
  for j := 0 to Height-1 do
    for i := 0 to Width - 1 do begin
      dc := gradient[i * 4 + j * WPicth];                         // gradient ől1140
      if dc > 255 then dc := 255;                                 // byte 255
      SetPixel(Pbm_Out, i, j, EdgeColor[GetBytePixel(PLongArray(edgeDir), i * 4, j)] * dc);
    end;
end;

// passe l'image en niveau de gris
//==============================================================================
procedure MakeGrayScale;
var
  i, j: integer;
begin
  for j := 0 to Height - 1 do
    for i := 0 to Width - 1 do
      case ColorMapMode of
        0: SetPixel(PLongArray(Tmp_In), i, j, RGBtoGray(GetPixel(Pbm_In, i, j)));           // GrayScale
        1: SetPixel(PLongArray(Tmp_In), i, j, getPixel(Pbm_In, i, j));                      // FRGB
        2: SetBytePixel(PLongArray(Tmp_In), i * 4, j, getbytePixel(Pbm_In, i * 4 + 2, j));  // Red
        3: SetBytePixel(PLongArray(Tmp_In), i * 4, j, getbytePixel(Pbm_In, i * 4 + 1, j));  // Green
        4: SetBytePixel(PLongArray(Tmp_In), i * 4, j, getbytePixel(Pbm_In, i * 4 + 0, j));  // Blue
      end;
end;

// applique un flou gaussien
//==============================================================================

procedure GaussianBlur(size: integer; theta: double);
var
  i, j, x, y: integer;
  col     : double;
  c       : Byte;
  theta2  : double;
  Gauss   : double;
  GaussSum: double;
  GaussMatrice: array of array of double;
begin
 // tB^[TCYPPRs[
  if size = 1 then begin
    for j := 0 to Height - 1 do
      for i := 0 to Width - 1 do
        SetPixel(Pbm_Out, i, j, getPixel(Pbm_In, i, j));
    exit;
  end;

  // Gauss matrice filter calc
  theta2 := 2 * theta * theta;
  size := size - 1;
  setlength(GaussMatrice, size * 2 + 1);
  GaussSum := 0;
  for j := -size to size do begin
    setlength(GaussMatrice[size + j], size * 2 + 1);
    for i := 0 to size do begin
      Gauss := exp(-(j * j + i * i) / theta2) / (pi * theta2);
      GaussMatrice[size + j, size + i] := Gauss;
      GaussSum := GaussSum + Gauss;                             // Ŝ1ɂȂȂ̂ōvlvZ
      if i = 0 then continue;                                   // 뎞SʒuȂ̂ŔΑȂ
      GaussMatrice[size + j, size - i] := Gauss;
      GaussSum := GaussSum + Gauss;                             // Ŝ1ɂȂȂ̂ōvlvZ
    end;
  end;

  // filter̓Kp
  for j := 0 to Height - 1 do
    for i := 0 to WPicth - 1 do
      if colormapcheck(i) then begin                            // vZ̏mF
        col := 0;
        for y := -size to size do
          for x := -size to size do begin
            c := getBytePixel(PLongArray(Tmp_In), i + x * 4, j + y);
            col := col + GaussMatrice[size + x, size + y] * c;
          end;
        SetBytePixel(Pbm_Out, i, j, round(col / GaussSum));     // vlŕ␳ ۑ
      end;
end;

// applique le filtre de Sobel qui recherche les contours suivant X et Y
//==============================================================================
const
  Matrice_Sobel_x: array[-1..1, -1..1] of integer = ((-1, 0, 1),  (-2, 0, 2),  (-1, 0, 1));   // array[ y, x]
  Matrice_Sobel_y: array[-1..1, -1..1] of integer = (( 1, 2, 1),  ( 0, 0, 0),  (-1,-2,-1));

procedure Sobel;
const
  angle45   = pi / 4;         // angle45   = 45
var
  i, j, x, y: integer;
  colx, coly: integer;
  c         : integer;
  angle     : Byte;
  grad      : Word;
begin
  // on efface le tableau
  for j := 0 to Height - 1 do
    for i := 0 to WPicth - 1 do
      gradient[i + j * WPicth] := 0;
  for j := 0 to Height - 1 do
    for i := 0 to Width - 1 do
      SetPixel(PLongArray(edgeDir),  i, j, 0);

  Maxg := 0;
  for j := 1 to Height - 2 do                                         // \[xtB^[TCYXL
    for i := 4 to WPicth - 5 do
      if colormapcheck(i) then begin
        colx := 0;
        coly := 0;
        for y := -1 to 1 do
          for x := -1 to 1 do begin
            c := getBytePixel(Pbm_Out, i + x * 4, j + y);
            colx := colx + Matrice_Sobel_x[y, x] * c;                 // X\[xtB^[
            coly := coly + Matrice_Sobel_y[y, x] * c;                 // Y\[xtB^[
          end;
        grad := Round(Sqrt(colx * colx + coly * coly));               // \[x̒lۑ  ől1140
        gradient[i + j * WPicth] := grad;
        if grad > Maxg then Maxg := grad;                             // őľ
        angle := round((ArcTan2(coly, colx) + pi) / angle45) mod 4;         // 0`3  edge pxW߂
        SetBytePixel(PLongArray(edgeDir), i, j, angle);
      end;
end;

// trace un trait sur chaque contour (Non maximum Suppression)
//==============================================================================
procedure findEdge(x_Shift, y_Shift, x, y:integer);
var
  g1, g2, g: Word;
begin
  g  := gradient[ x + y * WPicth];                                // ʒu̒l擾
  g1 := gradient[ x + x_Shift + (y + y_Shift) * WPicth];          // vXʒul擾
  g2 := gradient[ x - x_Shift + (y - y_Shift) * WPicth];          // }CiXʒul擾
  if (g > g1) and (g > g2) then begin                             // g ̒lԑ傫o͉摜ɂ̒lZbg
    if g > 255 then g := 255;                                     // \[xgradientől1140  byte255
    SetBytePixel(Pbm_Out, x, y, g);
  end
  else SetBytePixel(Pbm_Out, x, y, 0);                            // [Zbg
end;

procedure TraceAllEdges;
var
 i, j:integer;
begin
  for j := 1 to Height - 2 do
    for i := 4 to WPicth - 5 do
      if colormapcheck(i) then begin
        case GetBytePixel(PLongArray(edgeDir), i, j) of       // f[^[擾 ɂăGbWo
          0: findEdge( 4, 0, i, j);                           // E@@
          1: findEdge(-4, 1, i, j);                           //   E
          2: findEdge( 0, 1, i, j);                           // @@
          3: findEdge( 4, 1, i, j);                           // E  
        end;
      end;
end;

// cherche les points maxi sur les contours et efface les autres
//==============================================================================

procedure suppressNonMax( i, j: integer; lowerThreshold: byte);
begin
  // pas assez blanc
  if GetBytePixel(Pbm_Out, i, j) <= lowerThreshold then exit;
  // pas checked pos
  if GetBytePixel(PLongArray(Hyst), i, j) = 255 then exit;

  SetBytePixel(PLongArray(Hyst), i, j, 255);
  SetBytePixel(Pbm_Out, i, j, 255);
  // ͂WmF
  suppressNonMax(i - 4, j - 1, lowerThreshold);     // 
  suppressNonMax(i    , j - 1, lowerThreshold);     // 
  suppressNonMax(i + 4, j - 1, lowerThreshold);     // E
  suppressNonMax(i - 4, j    , lowerThreshold);     // 
  suppressNonMax(i + 4, j    , lowerThreshold);     // E
  suppressNonMax(i - 4, j + 1, lowerThreshold);     // 
  suppressNonMax(i    , j + 1, lowerThreshold);     // 
  suppressNonMax(i + 4, j + 1, lowerThreshold);     // E
end;

procedure Hysteresis(lowerThreshold, upperThreshold: byte);
var
  i, j: integer;
begin
  // on efface le tableau
  for j := 0 to Height - 1 do
    for i := 0 to Width - 1 do
      SetPixel(PLongArray(Hyst), i, j, 0);

  // ͂`FbNς݂ɂ܂B
  // ͂PC̓\[xtB^̓KpĂȂ̂ōɃZbg
  for j := 0 to Height - 1 do begin
    SetPixel(Pbm_Out,          0, j, 0);         // 
    SetPixel(Pbm_Out,  Width - 1, j, 0);         // E
  end;
  for i := 0 to Width  - 1 do begin
    SetPixel(Pbm_Out, i,          0, 0);         // 
    SetPixel(Pbm_Out, i, Height - 1, 0);         // 
  end;

  for j := 0 to Height - 1 do
    for i := 0 to WPicth - 1 do
      if colormapcheck(i) then begin
       // point dejEtraitE on passe au suivant
        if GetBytePixel(PLongArray(Hyst), i, j) = 255 then continue;
        // pas assez blanc pour le traitement
			  if GetBytePixel(Pbm_Out, i, j) < upperThreshold then continue;
	   	  suppressNonMax( i, j, lowerThreshold);
      end;
end;

// 255 ȉ O
procedure ClearNonWhitePixel;
var
  i, j: integer;
  c   : Byte;
begin
  for j := 0 to Height - 1 do
    for i := 0 to WPicth - 1 do
      if colormapcheck(i) then begin
        c := GetBytePixel(Pbm_Out, i, j);
			  if c < 255 then SetBytePixel(Pbm_Out, i, j, 0);
      end;
end;

// AddEgde  GbWǉ
//==============================================================================

// ͂W`FbN OȊOJEg
function CountNeighbors(i, j: integer): Byte;
begin
  result := 0;
  if GetBytePixel(Pbm_Out, i, j) = 0 then exit;

  if GetBytePixel(Pbm_Out, i + 4, j + 1) > 0 then inc(result);      // E
  if GetBytePixel(Pbm_Out, i    , j + 1) > 0 then inc(result);      // 
  if GetBytePixel(Pbm_Out, i - 4, j + 1) > 0 then inc(result);      // 

  if GetBytePixel(Pbm_Out, i + 4, j    ) > 0 then inc(result);      // E
  if GetBytePixel(Pbm_Out, i - 4, j    ) > 0 then inc(result);      // 

  if GetBytePixel(Pbm_Out, i + 4, j - 1) > 0 then inc(result);      // E
  if GetBytePixel(Pbm_Out, i    , j - 1) > 0 then inc(result);      // 
  if GetBytePixel(Pbm_Out, i - 4, j - 1) > 0 then inc(result);      // 
end;

type
  TMatrisse = array[1..6] of TPoint;

const
  Matrisses : array[0..3] of TMatrisse = (
                                                  //                 4 5 6
  ((x: -4; y: -1),(x: +0; y: -1),(x: +4; y: -1),  //                   C
   (x: -4; y: +1),(x: +0; y: +1),(x: +4; y: +1)), // Matrisse_N_S    1 2 3

                                                  //                   1 2
  ((x: +0; y: +1),(x: +4; y: +1),(x: +4; y: +0),  //                 4 C 3
   (x: -4; y: -0),(x: -4; y: -1),(x: -0; y: -1)), // Matrisse_NE_SW  5 6

                                                  //                 3   6
  ((x: -4; y: -1),(x: -4; y: +0),(x: -4; y: +1),  //                 2 C 5
   (x: +4; y: -1),(x: +4; y: +0),(x: +4; y: +1)), // Matrisse_E_W    1   4

                                                  //                 2 3
  ((x: -4; y: +0),(x: -4; y: +1),(x: -0; y: +1),  //                 1 C 4
   (x: +4; y: -0),(x: +4; y: -1),(x: +0; y: -1))  // Matrisse_NW_SE    6 5
  );

procedure findNextEdge(x, y: integer; mat: TMatrisse);
var
  dx, dy: integer;
  g: array[1..6] of Word;
  m, i, j: integer;
begin
  m := 0;
  for i := 1 to 6 do begin
    g[i] := gradient[ x + mat[i].X + (y + mat[i].Y) * WPicth];                // \[xl擾
    if GetBytePixel(Pbm_Out, x + mat[i].X, y + mat[i].Y) > 0 then g[i] := 0;  // o͒l255 g[l]=O
    if g[i] > Threshold then m := 1;               // wl傫ltOZbg
  end;
  // pas de voisin avec in gradient assez haut
  if m = 0 then exit;                              // wl傫lȂ獟܂

  m := 0;
  j := 0;
  for i := 1 to 6 do
    if g[i] > m then begin                         // ől
      m := g[i];
      j := i;
    end;
  dx := mat[j].X;
  dy := mat[j].y;
  SetBytePixel(Pbm_Out, x + dx, y + dy, 255);      // ől̏ꏊ𔒂
  if CountNeighbors(x + dx, y + dy) = 1 then       // ͂ɂOȊOPċAĂяo [_
    findNextEdge(x + dx, y + dy, Matrisses[GetBytePixel(PLongArray(edgeDir), x + dx, y + dy)]); // ZbgGbW
end;

// GbWČ
procedure AddEgde;
var
  i, j: integer;
begin
  for j := 1 to Height - 2 do                      // \[xtB^[TCYXL
    for i := 4 to WPicth - 5 do
      if colormapcheck(i) then begin
        if CountNeighbors(i , j) = 1 then          // i,j ̈ʒuOłȂ͂ɈꂩOȊO [_
          findNextEdge(i, j, Matrisses[GetBytePixel(PLongArray(edgeDir), i, j)]);   // ZbgGbW
      end;
end;

//==============================================================================
//==============================================================================

procedure Canny(const bm_in: TBitmap; const bm_out: TBitmap;
                GaussSize: integer; GaussTheta: double;
                lowerThreshold, upperThreshold: byte; addThreshold: Word;
                ColorMap, Level: integer);
begin
  // initialisation des variables
  Width := bm_In.Width;
  Height:= bm_In.Height;

  bm_Out.Width  := Width;                 // nĥ݌p̂ŏݒ
  bm_Out.Height := Height;

  bm_In.PixelFormat  := pf32bit;          // Formatϊ t@C24bit 
  bm_Out.PixelFormat := pf32bit;          // tH[}bgݒȂ̂łŐݒ

  WPicth := Width * 4;                    // 1 Pixel 4 bytes

  Pbm_In  := bm_In.ScanLine[Height - 1];  // 擪Ah|C^̃Zbg@
  Pbm_Out := bm_Out.ScanLine[Height - 1]; // [̕tȂ̂Œ  [0] ł͂mf [0] Ō̃C

  setlength(  Tmp_In,  Width * Height);   // z̑傫m Cardinal
  setlength( edgeDir,  Width * Height);   //                  Cardinal
  setlength(    Hyst,  Width * Height);   //                  Cardinal
  setlength(gradient, WPicth * Height);   // \[xlp     Word

  ColorMapMode := ColorMap;
  Threshold := addThreshold;

  // traitement de l'image
  MakeGrayScale;                              // O[XP[
  if level = 0 then begin
    copyimage(PLongArray(Tmp_In), Pbm_Out);
    exit;
  end;

  GaussianBlur(GaussSize, GaussTheta);        // KEXtB^[ɂڂ
  if level = 1 then exit;

  Sobel;                                      // X x \[xtB^[֊so \[x(tB^[)
  if level = 2 then begin
    ColorGradient;                            // z()FJ[\
    exit;
  end;

  if level = 3 then begin
    ColorDirection;                           // pxJ[\
    exit;
  end;

  TraceAllEdges;                              // GbWo \[x̒lƕlGbW
  if level = 4 then exit;

  Hysteresis(lowerThreshold, upperThreshold); // Abp[Xbh傫ꏊ̎͂
                                              // A[Xbh傫l
  if level = 5 then exit;

  ClearNonWhitePixel;                         // 255()菬l̓[() Non maximum Suppression
  if level = 6 then exit;

  AddEgde;                                    // GbWǉ wl傫\[x̒lƕGbWČ

end;

end.


